local me,ns=...
local abh=LibStub("AceAddon-3.0"):GetAddon(me)
local L=LibStub("AceLocale-3.0"):GetLocale(me,true)
local bs=LibStub("LibBattleScan")
local module=abh:GetModule("EOS")
local store
local rates=bs:GetRates('EOS')
local flags=bs:GetFlags("EOS")
local landmarks={1,2,3,4}
function sec2min(int)
	int=tonumber(int) or 0
	return format("%3d:%02d",int %60,floor(int/60))
end
function module:Init(AceGUI,storefunc)
	store=storefunc
	self:DashBoard(landmarks)
	self:SetHint()
	self:SetPrediction()
	self:SetFinals()
	self:SetFlags()
end
function module:Config()
	--abh:AddToggle("EOSSPAM",false,"Spam your life status")
	--abh:AddSlider("EOSSPAMTHRESHOLD",20,10,80,"Life percentage","Under this life percentage you will start asking for help")
end
function module:UpdateStates()
    local allyBases,allyScore,hordeBases,hordeScore,final = bs:GetStatus()
    final = tonumber(final) or 1600
    local allyRate=rates[allyBases]
    local hordeRate=rates[hordeBases]
--[===[@debug@
    self:SetDoubleRow('rates',allyRate,hordeRate,3,2)
--@end-debug@]===]
    local allyFlag=flags[allyBases] 
    local hordeFlag=flags[hordeBases]
    local allySecs=math.floor((final-allyScore)/allyRate) or -1
    local hordeSecs=math.floor((final-hordeScore)/hordeRate) or -1
--[===[@debug@
    self:SetDoubleRow('secs',sec2min(allySecs),sec2min(hordeSecs),11,10)
--@end-debug@]===]
    local timeLeft=hordeSecs
    if (allySecs <hordeSecs) then
    	timeLeft=allySecs
    end
    local faction
    if (allySecs > 0 or hordeSecs > 0 ) then
    	if (allySecs > hordeSecs) then
    		faction=FACTION_HORDE
    	elseif (allySecs < hordeSecs) then
    		faction=FACTION_ALLIANCE
    	else
    		faction=nil
    	end
    end
    self:SetPrediction(faction,timeLeft or 0)
	local nFlag=L["%s cant win without bases"]
	local n,m,t,delta
	local f=L["%s should take %d flags more than %s to win"]
	local allyFinal=math.min(ceil(allyRate * timeLeft + allyScore),final)
	local hordeFinal=math.min(ceil(hordeRate * timeLeft + hordeScore),final)
	if (allyFinal > hordeFinal and hordeBases > 0) then -- Ally wins
		delta=(allyFinal - hordeFinal)+1
		n=math.ceil(delta/hordeFlag)
		nFlag=f:format(FACTION_HORDE,n,FACTION_ALLIANCE)
	elseif  (hordeFinal > allyFinal and allyBases > 0) then -- Horde Wins
		delta=(hordeFinal - allyFinal)+1
		n=math.ceil(delta/hordeFlag)
		nFlag=f:format(FACTION_ALLIANCE,n,FACTION_HORDE)
	elseif (allyFinal == hordeFinal) then
		nFlag=L["Who takes more flags wins"]
	elseif (allyFinal > hordeFinal ) then -- Ally wins
		nFlag=nFlag:format(FACTION_ALLIANCE)
	elseif (allyFinal < hordeFinal ) then -- Horde wins
		nFlag=nFlag:format(FACTION_HORDE)
	end
	if (tonumber(delta) and tonumber(timeLeft)) then
		nFlag =nFlag .. format(L["(1 every %d seconds)"],math.floor(timeLeft/n))
	end
--[===[@debug@	
	self:SetHint(nFlag)
--@end-debug@]===]
	self:SetFinals(allyFinal,hordeFinal)
	self:SetFlags(allyFlag,hordeFlag)
end